> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get video

> Information about a video entity.

Contains all the data about the video: meta-data, data for streaming and renditions, static media data, data about original video.

You can use different methods to play video:
- `iframe_url` – a URL to a built-in HTML video player with automatically configured video playback.
- `hls_url` – a URLs to HLS TS .m3u8 manifest, which can be played in video players.
- `hls_cmaf_url` – a URL to HLS CMAF .m3u8 manifest with chunks in fMP4 format, which can be played in most modern video players.
- `dash_url` – a URL to MPEG-DASH .mpd manifest, which can be played in most modern video players. Preferable for Android and Windows devices.
- `converted_videos`/`mp4_url` – a URL to MP4 file of specific rendition.

![Video player](https://demo-files.gvideo.io/apidocs/coffee-run-player.jpg)



## OpenAPI

````yaml /api-reference/services_documented/streaming_api.yaml get /streaming/videos/{video_id}
openapi: 3.1.0
info:
  title: Gcore OpenAPI – Streaming API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-11T15:10:30.328297+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: AI
    x-displayName: AI
  - name: Broadcasts
    x-displayName: Broadcasts
  - name: Directories
    x-displayName: Directories
  - name: Overlays
    x-displayName: Overlays
  - name: Players
    x-displayName: Players
  - name: Playlists
    x-displayName: Playlists
  - name: QualitySets
    x-displayName: QualitySets
  - name: Restreams
    x-displayName: Restreams
  - name: Streaming Statistics
    x-displayName: Statistics
  - name: Streams
    x-displayName: Streams
  - name: Subtitles
    x-displayName: Subtitles
  - name: Videos
    x-displayName: Videos
paths:
  /streaming/videos/{video_id}:
    get:
      tags:
        - Videos
      summary: Get video
      description: >-
        Information about a video entity.


        Contains all the data about the video: meta-data, data for streaming and
        renditions, static media data, data about original video.


        You can use different methods to play video:

        - `iframe_url` – a URL to a built-in HTML video player with
        automatically configured video playback.

        - `hls_url` – a URLs to HLS TS .m3u8 manifest, which can be played in
        video players.

        - `hls_cmaf_url` – a URL to HLS CMAF .m3u8 manifest with chunks in fMP4
        format, which can be played in most modern video players.

        - `dash_url` – a URL to MPEG-DASH .mpd manifest, which can be played in
        most modern video players. Preferable for Android and Windows devices.

        - `converted_videos`/`mp4_url` – a URL to MP4 file of specific
        rendition.


        ![Video
        player](https://demo-files.gvideo.io/apidocs/coffee-run-player.jpg)
      operationId: get_api_videos_id
      parameters:
        - name: video_id
          in: path
          description: Video ID
          required: true
          schema:
            type: integer
      responses:
        '200':
          description: Successful
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/searchVideo'
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            video = client.streaming.videos.get(
                0,
            )
            print(video.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/option\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tvideo, err := client.Streaming.Videos.Get(context.TODO(), 0)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", video.ID)\n}\n"
components:
  schemas:
    searchVideo:
      type: object
      properties:
        id:
          type: integer
          description: Video ID
        name:
          type: string
          description: >-
            Title of the video.


            Often used as a human-readable name of the video, but can contain
            any text you wish. The values are not unique and may be repeated.

            Examples:

            - Educational training 2024-03-29

            - Series X S3E14, The empire strikes back

            - 480fd499-2de2-4988-bc1a-a4eebe9818ee
        description:
          type: string
          description: Additional text field for video description
        client_id:
          type: integer
          description: Client ID
        origin_size:
          type: integer
          description: Size of original file
        origin_video_duration:
          type: integer
          description: Original video duration in milliseconds
        origin_url:
          type: string
          description: >-
            URL to an original file from which the information for transcoding
            was taken. 


            May contain a link for scenarios:

            - If the video was downloaded from another origin

            - If the video is a recording of a live stream

            - Otherwise it is "null"


            **Copy from another server**

            URL to an original file that was downloaded. Look at method "Copy
            from another server" in POST /videos.

            **Recording of an original live stream** 


            URL to the original non-transcoded stream recording with original
            quality, saved in MP4 format. File is created immediately after the
            completion of the stream recording. The stream from which the
            recording was made is reflected in "stream_id" field.


            Can be used for internal operations when a recording needs to be
            received faster than the transcoded versions are ready. But this
            version is not intended for public distribution. Views and downloads
            occur in the usual way, like viewing an MP4 rendition.


            The MP4 file becomes available for downloading when the video entity
            "status" changes from "new" to "pending". 


            Format of URL is
            ```/videos/<cid>_<slug>/origin_<bitrate>_<height>.mp4```

            Where:

            - ```<bitrate>``` – Encoding bitrate in Kbps.

            - ```<height>``` – Video height.


            The original file is stored for up to 7 days, after which it is
            deleted automatically. By default, the retention policy for original
            recorded files cannot be changed. For enterprise customers, it can
            be adjusted individually upon request.


            This is a premium feature, available only upon request through your
            manager or support team.
          default: null
        duration:
          type: integer
          description: >-
            Video duration in milliseconds. May differ from
            "origin_video_duration" value if the video was uploaded with
            clipping through the parameters "clip_start_seconds" and
            "clip_duration_seconds"
        slug:
          type: string
          description: >-
            A unique alphanumeric identifier used in public URLs to retrieve and
            view the video. It is unique for each video, generated randomly and
            set automatically by the system.


            Format of usage in URL is *.../videos/{`client_id`}_{slug}/...*


            Example:

            - Player: /videos/`12345_neAq1bYZ2`

            - Manifest: /videos/`12345_neAq1bYZ2`/master.m3u8

            - Rendition: /videos/`12345_neAq1bYZ2`/`qid90v1_720`.mp4
        stream_id:
          type: integer
          description: >-
            If the video was saved from a stream, then ID of that stream is
            saved here
        recording_started_at:
          type: string
          description: >-
            If the video was saved from a stream, then start time of the stream
            recording is saved here. Format is date time in ISO 8601
        share_url:
          type: string
          description: >-
            Custom URL or iframe displayed in the link field when a user clicks
            on a sharing button in player. If empty, the link field and social
            network sharing is disabled
        poster:
          type: string
          default: null
          description: >-
            Poster is your own static image which can be displayed before the
            video begins playing. This is often a frame of the video or a custom
            title screen.


            Field contains a link to your own uploaded image.


            Also look at "screenshot" attribute.
        poster_thumb:
          type: string
          default: null
          description: >-
            Field contains a link to minimized poster image. Original "poster"
            image is proportionally scaled to a size of 200 pixels in height.
        screenshot:
          type: string
          description: >-
            A URL to the default screenshot is here. The image is selected from
            an array of all screenshots based on the “`screenshot_id`”
            attribute. If you use your own "poster", the link to it will be here
            too.


            Our video player uses this field to display the static image before
            the video starts playing. As soon as the user hits "play" the image
            will go away.

            If you use your own external video player, then you can use the
            value of this field to set the poster/thumbnail in your player.


            Example:

            - `video_js`.poster: ```api.screenshot```

            - clappr.poster: ```api.screenshot```
        screenshots:
          type: array
          items:
            type: string
          description: >-
            Array of auto generated screenshots from the video. By default 5
            static screenshots are taken from different places in the video. If
            the video is short, there may be fewer screenshots.


            Screenshots are created automatically, so they may contain not very
            good frames from the video. To use your own image look at "poster"
            attribute.
        screenshot_id:
          type: integer
          description: >-
            ID of auto generated screenshots to be used for default screenshot.


            Counting from 0. A value of -1 sets the "screenshot" attribute to
            the URL of your own image from the "poster" attribute.
          default: null
        sprite:
          type: string
          description: >-
            Link to picture with video storyboard. Image in JPG format. The
            picture is a set of rectangles with frames from the video. Typically
            storyboard is used to show preview images when hovering the video's
            timeline.
          default: null
        sprite_vtt:
          type: string
          description: >-
            Storyboard in VTT format. This format implies an explicit indication
            of the timing and frame area from a large sprite image.
          default: null
        ad_id:
          type: integer
          description: >-
            ID of ad that should be shown. If empty the default ad is show. If
            there is no default ad, no ad is shownю
        hls_url:
          type: string
          description: >-
            A URL to a master playlist HLS (master.m3u8).

            Chunk type will be selected automatically:

            - TS if your video was encoded to H264 only.

            - CMAF if your video was encoded additionally to H265 and/or AV1
            codecs (as Apple does not support these codecs over MPEG TS, and
            they are not standardized in TS-container).

              


            You can also manually specify suffix-options that will allow you to
            change the manifest to your request:


            ```

            /videos/{client_id}_{video_slug}/master[-cmaf][-min-N][-max-N][-img][-(h264|hevc|av1)].m3u8

            ```


            List of suffix-options:

            - [-cmaf] – getting HLS CMAF version of the manifest. Look at the
            ```hls_cmaf_url``` field.

            - [-min-N] – ABR soft limitation of qualities from below.

            - [-max-N] – ABR soft limitation of qualities from above.

            - [-img] – Roku trick play: to add tiles directly into .m3u8
            manifest. Read the Product Documentation for details.

            - [-(h264|hevc|av1) – Video codec soft limitation. Applicable if the
            video was transcoded into multiple codecs H264, H265 and AV1 at
            once, but you want to return just 1 video codec in a manifest. Read
            the Product Documentation for details.
              
            ABR soft-limiting: Soft limitation of the list of qualities allows
            you to return not the entire list of transcoded qualities for a
            video, but only those you need.

            For example, the video is available in 7 qualities from 360p to 4K,
            but you want to return not more than 480p only due to the conditions
            of distribution of content to a specific end-user (i.e. free
            account):

            ABR soft-limiting examples:

            - To a generic ```.../master.m3u8``` manifest

            - Add a suffix-option to limit quality ```.../master-max-480.m3u8```

            - Add a suffix-option to limit quality and codec
            ```.../master-min-320-max-320-h264.m3u8```

            For more details look at the Product Documentation.
              
            Caution. Solely master.m3u8 (and master[-options].m3u8) is
            officially documented and intended for your use. Any additional
            internal manifests, sub-manifests, parameters, chunk names, file
            extensions, and related components are internal infrastructure
            entities. These may undergo modifications without prior notice, in
            any manner or form. It is strongly advised not to store them in your
            database or cache them on your end.
        hls_cmaf_url:
          type: string
          description: >-
            A URL to a master playlist HLS (master-cmaf.m3u8) with CMAF-based
            chunks. Chunks are in fMP4 container. It's a code-agnostic
            container, which allows to use any like H264, H265, AV1, etc.
              


            It is possible to use the same suffix-options as described in the
            "hls_url" attribute.
              


            Caution. Solely master.m3u8 (and master[-options].m3u8) is
            officially documented and intended for your use. Any additional
            internal manifests, sub-manifests, parameters, chunk names, file
            extensions, and related components are internal infrastructure
            entities. These may undergo modifications without prior notice, in
            any manner or form. It is strongly advised not to store them in your
            database or cache them on your end.
        dash_url:
          type: string
          description: >-
            A URL to a master playlist MPEG-DASH (master.mpd) with CMAF or WebM
            based chunks.


            Chunk type will be selected automatically for each quality:

            - CMAF for H264 and H265 codecs.

            - WebM for AV1 codec.

              


            This URL is a link to the main manifest. But you can also manually
            specify suffix-options that will allow you to change the manifest to
            your request:


            ```

            /videos/{client_id}_{slug}/master[-min-N][-max-N][-(h264|hevc|av1)].mpd

            ```


            List of suffix-options:

            - [-min-N] – ABR soft limitation of qualities from below.

            - [-max-N] – ABR soft limitation of qualities from above.

            - [-(h264|hevc|av1) – Video codec soft limitation. Applicable if the
            video was transcoded into multiple codecs H264, H265 and AV1 at
            once, but you want to return just 1 video codec in a manifest. Read
            the Product Documentation for details.


            Read more what is ABR soft-limiting in the "hls_url" field above.

              


            Caution. Solely master.mpd is officially documented and intended for
            your use. Any additional internal manifests, sub-manifests,
            parameters, chunk names, file extensions, and related components are
            internal infrastructure entities. These may undergo modifications
            without prior notice, in any manner or form. It is strongly advised
            not to store them in your database or cache them on your end.
        iframe_url:
          type: string
          description: >-
            A URL to a built-in HTML video player with the video inside. It can
            be inserted into an iframe on your website and the video will
            automatically play in all browsers.


            The player can be opened or shared via this direct link. Also the
            video player can be integrated into your web pages using the Iframe
            tag.


            Example of usage on a web page:

            <iframe width="100%" height="100%"
            src="https://player.gvideo.co/videos/2675_FnlHXwA16ZMxmUr"
            frameborder="0" allow="autoplay; encrypted-media"
            allowfullscreen></iframe>
              


            There are some link modificators you can specify and add manually:

            - ?`no_low_latency` – player is forced to use non-low-latency
            streams HLS MPEG-TS, instead of MPEG-DASH CMAF or HLS/LL-HLS CMAF.

            - ?t=(integer) – time to start playback from specified point in the
            video. Applicable for VOD only.

            - ?`sub_lang`=(language) – force subtitles to specific language (2
            letters ISO 639 code of a language).

            - Read more in the Product Documentation.
        custom_iframe_url:
          type: string
          description: >-
            Custom URL of Iframe for video player to be used in share panel in
            player. Auto generated Iframe URL provided by default.
        views:
          type: integer
          description: >-
            Number of video views through the built-in HTML video player of the
            Streaming Platform only. This attribute does not count views from
            other external players and native OS players, so here may be less
            number of views than in "cdn_views".
        cdn_views:
          type: integer
          description: >-
            Total number of video views. It is calculated based on the analysis
            of all views, no matter in which player.
        client_user_id:
          type: integer
          default: null
          description: >-
            Custom meta field for storing the Identifier in your system. We do
            not use this field in any way when processing the stream. Example:
            ```client_user_id = 1001```
        status:
          type: string
          description: >-
            Video processing status:

            - empty – initial status, when video-entity is created, but
            video-file has not yet been fully uploaded (TUS uploading, or
            downloading from an origin is not finished yet)

            - pending – video is in queue to be processed

            - viewable – video has at least 1 quality and can already be viewed
            via a link, but not all qualities are ready yet

            - ready – video is completely ready, available for viewing with all
            qualities

            - error – error while processing a video, look at "error" field
          enum:
            - empty
            - pending
            - viewable
            - ready
            - error
        error:
          type: string
          description: 'Video processing error text will be saved here if "status: error"'
        projection:
          type: string
          description: |-
            Regulates the video format:

            - **regular** — plays the video as usual
            - **vr360** — plays the video in 360 degree mode
            - **vr180** — plays the video in 180 degree mode
            - **vr360tb** — plays the video in 3D 360 degree mode Top-Bottom.

              
             Default is regular
        converted_videos:
          type: array
          description: Array of data about each transcoded quality
          items:
            type: object
            properties:
              id:
                type: integer
                description: ID of the converted file of the specific quality
              name:
                type: string
                description: Specific quality name
              width:
                type: integer
                description: >-
                  Width in pixels of the converted video file of the specified
                  quality. Can be ```null``` for audio files.
                default: null
              height:
                type: integer
                description: >-
                  Height in pixels of the converted video file of the specific
                  quality. Can be ```null``` for audio-only files.
                default: null
              size:
                type: integer
                description: >-
                  Size in bytes of the converted file of the specific quality.
                  Can be ```null``` until transcoding is fully completed.
                default: null
              progress:
                type: integer
                description: Status of transcoding into the specific quality, from 0 to 100
              status:
                type: string
                description: |-
                  Status of transcoding:
                  - processing – video is being transcoded to this quality,
                  - complete – quality is fully processed,
                  - error – quality processing error, see parameter "error".
                enum:
                  - processing
                  - complete
                  - error
              error:
                type: string
                description: Video processing error text in this quality
                default: null
              mp4_url:
                type: string
                description: >-
                  A URL to a rendition file of the specified quality in MP4
                  format for downloading.
                    


                  **Download methods**


                  For each converted video, additional download endpoints are
                  available under `converted_videos`/`mp4_urls`.

                  An MP4 download enpoints:

                  1. `/videos/{client_id}_{slug}/{filename}.mp4`

                  2. `/videos/{client_id}_{slug}/{filename}.mp4/download`

                  3.
                  `/videos/{client_id}_{slug}/{filename}.mp4/download={custom_filename}`


                  The first option returns the file as is.

                  Response will be:


                  ```

                  GET .mp4

                  ...

                  content-type: video/mp4

                  ```


                  The second option with `/download` will respond with HTTP
                  response header that directly tells browsers to download the
                  file instead of playing it in the browser:


                  ``` 

                  GET .mp4/download

                  ...

                  content-type: video/mp4

                  content-disposition: attachment

                  access-control-expose-headers: Content-Disposition

                  ```


                  The third option allows you to set a custom name for the file
                  being downloaded. You can optionally specify a custom filename
                  (just name excluding the .mp4 extension) using the download=
                  query.


                  Filename constraints:

                  - Length: 1-255 characters

                  - Must NOT include the .mp4 extension (it is added
                  automatically)

                  - Allowed characters: a-z, A-Z, 0-9, _(underscore), -(dash),
                  .(dot)

                  - First character cannot be .(dot)

                  - Example valid filenames: ```holiday2025```,
                  ```_backup.final```, ```clip-v1.2```


                  ```

                  GET .mp4/download={custom_filename}

                  ...

                  content-type: video/mp4

                  content-disposition: attachment;
                  filename="{custom_filename}.mp4"

                  access-control-expose-headers:
                  Content-Disposition                    

                  ```


                  Examples:

                  - MP4:
                  ```https://demo-public.gvideo.io/videos/2675_1OFgHZ1FWZNNvx1A/qid3567v1_h264_4050_1080.mp4/download```

                  - MP4 with custom download filename:
                  ```https://demo-public.gvideo.io/videos/2675_1OFgHZ1FWZNNvx1A/qid3567v1_h264_4050_1080.mp4/download=highlights_v1.1_2025-05-30```

                    


                  **Default MP4 file name structure**


                  Link to the file {filename} contains information about the
                  encoding method using format:


                  ```<quality_version>_<codec>_<bitrate>_<height>.mp4```

                  - ```<quality_version>``` – Internal quality identifier and
                  file version. Please do not use it, can be changed at any time
                  without any notice.

                  - ```<codec>``` – Codec name that was used to encode the
                  video, or audio codec if it is an audio-only file.

                  - ```<bitrate>``` – Encoding bitrate in Kbps.

                  - ```<height>``` – Video height, or word "audio" if it is an
                  audio-only file.


                  Note that this link format has been applied since 14.08.2024.
                  If the video entity was uploaded earlier, links may have old
                  simplified format.


                  Example: ```
                  /videos/{client_id}_{slug}/qid3567v1_h264_4050_1080.mp4 ```

                    


                  **Dynamic speed limiting**

                  This mode sets different limits for different users or for
                  different types of content. The speed is adjusted based on
                  requests with the “speed” and “buffer” arguments.


                  Example: ``` ?speed=50k&buffer=500k ```


                  Read more in Product Documentation in CDN section "Network
                  limits". 

                    


                  **Secure token authentication for MP4 (updated)**


                  Access to MP4 download links only can be protected using
                  advanced secure tokens passed as query parameters.


                  Token generation uses the entire MP4 path, which ensures the
                  token only grants access to a specific quality/version of the
                  video. This prevents unintended access to other bitrate
                  versions of an ABR stream.


                  Token Query Parameters:

                  - token: The generated hash

                  - expires: Expiration timestamp

                  - speed: (optional) Speed limit in bytes/sec, or empty string

                  - buffer: (optional) Buffer size in bytes, or empty string


                  Optional (for IP-bound tokens):

                  - ip: The user’s IP address

                  Example: ``` ?md5=QX39c77lbQKvYgMMAvpyMQ&expires=1743167062
                  ```


                  Read more in Product Documentation in Streaming section
                  "Protected temporarily link".
      example:
        id: 70575
        name: Coffee Run - Blender Open Movie 720p
        description: >-
          Fueled by caffeine, a young woman runs through the bittersweet
          memories of her past relationship. Coffee Run was directed by Hjalti
          Hjalmarsson and produced by the team at Blender Studio.
        client_id: 1
        duration: 184669
        slug: FnlHXwA16ZMxmUr
        status: ready
        origin_size: 29260881
        origin_video_duration: 184669
        origin_audio_channels: 2
        origin_height: 804
        origin_width: 1920
        created_at: '2024-06-13T12:15:25.000Z'
        updated_at: '2024-07-26T15:30:50.000Z'
        clip_start_seconds: null
        clip_duration_seconds: null
        hls_url: https://demo-public.gvideo.io/videos/2675_FnlHXwA16ZMxmUr/master.m3u8
        hls_cmaf_url: >-
          https://demo-public.gvideo.io/videos/2675_FnlHXwA16ZMxmUr/master-cmaf.m3u8
        dash_url: https://demo-public.gvideo.io/videos/2675_FnlHXwA16ZMxmUr/master.mpd
        iframe_url: https://player.gvideo.co/videos/2675_FnlHXwA16ZMxmUr
        poster: >-
          https://static.gvideo.co/videoplatform/posters/video/10507272/f55b7db5f7a1ea48d713d7e6806bb9c5.jpeg
        poster_thumb: >-
          https://static.gvideo.co/videoplatform/posters/video/10507272/thumb_f55b7db5f7a1ea48d713d7e6806bb9c5.jpeg
        screenshot: >-
          https://static.gvideo.co/videoplatform/posters/video/10507272/f55b7db5f7a1ea48d713d7e6806bb9c5.jpeg
        screenshots:
          - >-
            https://static.gvideo.co/videoplatform/thumbnails/2675/2474723_FnlHXwA16ZMxmUr.mp4_2_1080.jpg
          - >-
            https://static.gvideo.co/videoplatform/thumbnails/2675/2474723_FnlHXwA16ZMxmUr.mp4_3_1080.jpg
        screenshot_id: -1
        views: 2000001
        cdn_views: 30000003
        projection: regular
        sprite: >-
          https://static.gvideo.co/videoplatform/sprites/2675/10507272_sNOwd4luk5mGGf9M.mp4_sprite.jpg
        sprite_vtt: |
          1
          00:00:00,000 --> 00:00:05,000
          xMbWbUSuvJ8NX2_sprite.jpg#xywh=0,0,100,42

          2
          00:00:05,000 --> 00:00:10,000
          xMbWbUSuvJ8NX2_sprite.jpg#xywh=100,0,100,42
          ...
        converted_videos:
          - id: 25889825
            name: vod720p
            width: 1719
            height: 720
            size: 37651798
            progress: 100
            status: complete
            mp4_url: >-
              https://demo-public.gvideo.io/videos/2675_FnlHXwA16ZMxmUr/qid3570v3_h264_1566_720.mp4
          - id: 25889828
            name: vod480p
            width: 1146
            height: 480
            size: 20255892
            progress: 100
            status: complete
            mp4_url: >-
              https://demo-public.gvideo.io/videos/2675_FnlHXwA16ZMxmUr/qid3573v3_h264_800_468.mp4
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````